echo off/m

{This procedure passes values in a result table
 to the progam graph.exe as command-line parameters}

load pm

{Initialise the pseudo-boolean variable to false}
assign into %parms_assigned 0

{Screen 1 executes a query to produce a suitable result
 table.  To operate on an existing result table, delete
 the following call to this screen}
call 1

enter into %response @+1,1 /1/vyYnN;/uView graph? (y/n)
if &response = Y
  {Screen 2 sets up the command-line parameters and
   executes the graph program}
  call 2
endif

{Screen 3 tidies up and terminates}
call 3

screen 1
select   state_born, count(*)
from     prime_minister
group by state_born;
return

screen 2
{Code within a screen repeats until a return
 command is encountered}

if &parms_assigned {Initially false}
  {Invoke graph.exe with appropriate command-line
   parameters to draw the bar graph}
  assign into %progname &sysdbpath'graph'
  execute &progname &titles &values
  return
else
  send @+1,1 Preparing to call graph program ...
  assign into %titles ' '
  assign into %values ' '
  fetch fields

  {Code repeats from this point until all
   values in result table are assigned}
  fetch into %group
  fetch into %value

  if &group null
    assign into %group ?
  {Note: a single question mark is always
   converted to a null representation}
  endif

  {The next two assign commands concatenate the
   class titles and y values respectively}
  assign into %titles &titles &group
  assign into %values &values &value
  {Set pseudo-boolean variable to true}
  assign into %parms_assigned 1

endif

screen 3
send @24,1
