echo off/m

{microSQL procedure to illustrate screen-based data entry}

set display off

{Define the data-entry menu}

case

draw pment +pmmenu
send @24,19

{Accept the required option}

accept

{Define the screen to enter data for a prime minister}

screen 1

draw pment +pmcols
send @25,1/green,b  <F1> for help
send @25,54/green,b  <Esc> to exit data entry

{Accept the required pm name}

enter into %pm_name @11,40 /12/cy,b;
send @25,1/green,b

{Check that the name is not already in the pm table}

select count(*)
from   prime_minister
where  pm_name = '&pm_name';

assign into %pm_count 0
fetch fields
fetch into %pm_count
if &pm_count <> 0
  send /red,b
  pause /3  This pm data has already been entered
else

  {Space over <esc> message and get remaining data values}

  space @25,54/yellow/off,b/high 26
  enter into %birth_yr @16,17 /4/d1930,1970/cb,b;
  enter into %yrs_served @16,42 /5/d0,20/cb,b;
  enter into %death_age @16,65 /2/d20,100/cb,b;
  enter into %state_born @19,17 /3/u/cb,b;
  enter into %state_rep @19,73 /3/u/cb,b;

  {Insert values into table}

  insert into prime_minister
  values ('&pm_name',&birth_yr, &yrs_served, &death_age,
          '&state_born','&state_rep');

endif

{Define help panel}

panel

send @22,1/green,b  Enter  the indicated  details for a
send @+1,1  new  prime minister.  If a  partic'-'
send @+1,1  ular value is unknown, enter a "?".
pause @+1,1  Press a key to continue ...
send /yellow/off,b/high
space block 22,1 25,37
send @25,1/green,b  <F1> for help

{Define marriage screen}

screen 2

{Not implemented}

call 5
return

{Define recreation screen}

screen 3

{Not implemented}

call 5
return

{Define ministry screen}

screen 4

{Not implemented}

call 5
return

{Define deputy pm screen}

screen 5

{Not implemented}

send @24,1 /red,b  This option is not implemented
pause /3
return

{Define the exit screen}

screen 6

{Tidy up and return to calling procedure}

send @24,1/green,b  Loading main program ...
set display on
send /normal
